=== src_generator/Makefile ===
#
#===============================
# deviceXlib package
#===============================
#
-include ../make.inc

DIR=src_gener

#
# main targets
#
all: memcpy auxfunc buffers mapping malloc memset

memcpy auxfunc buffers mapping malloc memset:
	if [ -x generate_$@.py ] ; then ./generate_$@.py ; \
	   mv *.f90 ../src ; fi

# clean
clean:
	 - /bin/rm -rf *.f90 *.F __*__
distclean:   clean

# dependencies
include make.depend
