=== debian/changelog ===
devicexlib (0.8.6-2) unstable; urgency=medium

  * Team upload.
  [ Adrian Bunk ]
  * libdevicexlib-dev: Drop Multi-Arch: same. Closes: #1103731.
  [ Santiago Vila ]
  * Fix clean target. Closes: #1044973.

 -- Santiago Vila <sanvila@debian.org>  Fri, 23 May 2025 21:55:00 +0200

devicexlib (0.8.6-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: Updated. 
  * debian/patches/fix_ppc64le_configure.patch: Refreshed.

 -- Michael Banck <mbanck@debian.org>  Sun, 06 Apr 2025 10:04:12 +0200
