=== debian/control ===
Source: devicexlib
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: architecture-is-64-bit,
               debhelper (>> 12~),
               gfortran,
               libblas-dev,
               liblapack-dev
Standards-Version: 4.4.1
Homepage: https://gitlab.com/max-centre/components/devicexlib
Vcs-Browser: https://salsa.debian.org/debichem-team/devicexlib
Vcs-Git: https://salsa.debian.org/debichem-team/devicexlib.git

Package: libdevicexlib-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Library wrapping device-oriented routines and utilities
 The deviceXlib library wraps device-oriented routines and utilities.
 .
 This package contains the static library.
