=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://gitlab.com/max-centre/components/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
